schedule function vg:1s 1s

#ADD ENTITIES TO TEAM
team modify player collisionRule pushOwnTeam
team modify player seeFriendlyInvisibles false
team join player @e[type=skeleton,tag=vg.village_guard,team=!player]
team join player @e[type=iron_golem,tag=!smithed.entity,team=]
team join player @e[type=snow_golem,tag=!smithed.entity,team=]
team join player @e[type=turtle,tag=!smithed.entity,team=]
team join player @e[type=villager,tag=!smithed.entity,team=]
team join player @e[type=wandering_trader,tag=!smithed.entity,team=]
team join player @e[type=wolf,tag=!smithed.entity,team=]
team leave @e[type=zombie_villager,team=player,tag=vg.protected,tag=!smithed.entity]
tag @e[type=zombie_villager,tag=vg.protected,tag=!smithed.entity] remove vg.protected

#VILLAGE GUARDS PICKUP ITEMS
execute as @e[type=skeleton,tag=vg.village_guard] at @s unless data entity @s HandItems[1].id run execute if entity @e[type=item,distance=..1.5,nbt={Item:{id:"minecraft:totem_of_undying",count:1}}] run function vg:pickup/totem
execute as @e[type=skeleton,tag=vg.village_guard] at @s unless data entity @s HandItems[1].id run execute if entity @e[type=item,distance=..1.5,nbt={Item:{id:"minecraft:shield",count:1}}] run function vg:pickup/shield
execute as @e[type=skeleton,tag=vg.village_guard,nbt={HandItems:[{id:"minecraft:iron_axe"}]}] at @s unless data entity @s HandItems[1].id run execute if entity @e[type=item,distance=..1.5,nbt={Item:{id:"minecraft:iron_axe",count:1}}] run function vg:pickup/iron_axe
execute as @e[type=skeleton,tag=vg.village_guard,nbt={HandItems:[{id:"minecraft:bow"}]}] at @s unless data entity @s HandItems[1].id run execute if entity @e[type=item,distance=..1.5,nbt={Item:{id:"minecraft:spectral_arrow",count:1}}] run function vg:pickup/spectral_arrow
execute as @e[type=skeleton,tag=vg.village_guard,nbt={HandItems:[{id:"minecraft:bow"}]}] at @s unless data entity @s HandItems[1].id run execute if entity @e[type=item,distance=..1.5,nbt={Item:{id:"minecraft:tipped_arrow",count:1}}] run function vg:pickup/tipped_arrow

#PROTECT THE MOBS
tag @e[type=villager,tag=!smithed.entity,tag=!vg.protected,team=player] add vg.protected
tag @e[type=iron_golem,nbt={PlayerCreated:0b},tag=!smithed.entity,tag=!vg.protected,team=player] add vg.protected

#TAG DEFAULT ENEMY MOBS
tag @e[type=#raiders,team=!player,tag=!smithed.entity,tag=!vg.protected,tag=!vg.enemy_mob] add vg.enemy_mob
tag @e[type=creeper,team=!player,tag=!smithed.entity,tag=!vg.protected,tag=!vg.enemy_mob] add vg.enemy_mob
tag @e[type=zombie,team=!player,tag=!smithed.entity,tag=!vg.protected,tag=!vg.enemy_mob] add vg.enemy_mob
tag @e[type=husk,team=!player,tag=!smithed.entity,tag=!vg.protected,tag=!vg.enemy_mob] add vg.enemy_mob
tag @e[type=zoglin,team=!player,tag=!smithed.entity,tag=!vg.protected,tag=!vg.enemy_mob] add vg.enemy_mob
tag @e[type=zombified_piglin,team=!player,tag=!smithed.entity,tag=!vg.protected,tag=!vg.enemy_mob] add vg.enemy_mob

#TAG ENEMY MOB
execute as @e[type=!zombie_villager,type=!player,team=!player,predicate=vg:angryat] at @s run tag @s add vg.enemy_mob
execute as @e[type=zombie_villager,team=!player,predicate=vg:angryat/near] at @s run tag @s add vg.enemy_mob

#SET NEAREST ENEMY AS TARGET
execute as @e[type=!player,tag=vg.protected,nbt=!{Invulnerable:1b}] at @s run tag @e[type=!player,tag=vg.enemy_mob,tag=!vg.curr_tgt,nbt=!{Invulnerable:1b},distance=..16] add vg.curr_tgt
execute as @a[tag=vg.protected,gamemode=!creative,gamemode=!spectator] at @s run tag @e[type=!player,tag=vg.enemy_mob,tag=!vg.curr_tgt,nbt=!{Invulnerable:1b},distance=..16] add vg.curr_tgt
execute as @e[type=!player,tag=vg.protected,nbt=!{Invulnerable:1b}] at @s run tag @a[gamemode=!creative,gamemode=!spectator,advancements={vg:warning/enemy=true},tag=!vg.curr_tgt,distance=..16] add vg.curr_tgt

#SUMMON HIT FROM MOB
execute as @e[type=skeleton,tag=vg.village_guard,predicate=!vg:angry,limit=5,sort=random] at @s run execute if entity @e[type=!player,type=!wolf,nbt=!{Invulnerable:1b},tag=vg.curr_tgt,distance=..100] run function vg:trigger/1

#SUMMON HIT FROM BAD PLAYER
execute as @e[type=skeleton,tag=vg.village_guard,predicate=!vg:angry,limit=5,sort=random] at @s run execute if entity @p[gamemode=!creative,gamemode=!spectator,tag=vg.curr_tgt,distance=..100] run function vg:trigger/2

#CREATE IRON GOLEM'S HATE WITH TARGET PLAYER
execute as @e[type=iron_golem,nbt={PlayerCreated:0b},predicate=!vg:angry] at @s run execute if entity @a[gamemode=!creative,gamemode=!spectator,tag=vg.curr_tgt,distance=..16] run data modify entity @s AngryAt set from entity @p[gamemode=!creative,gamemode=!spectator,tag=vg.curr_tgt,distance=..16] UUID

#TELEPORT BACK TO VILLAGER
execute as @e[type=skeleton,tag=vg.village_guard,predicate=!vg:angry,predicate=vg:chance_10] at @s run execute unless entity @e[nbt=!{Invulnerable:1b},tag=vg.protected,tag=!vg.village_guard,distance=..64] run execute if entity @e[type=villager,nbt=!{Invulnerable:1b}] run function vg:teleport/to_villager

#NO CAVES EXPLORING FOR VILLAGE GUARD
execute as @e[type=skeleton,tag=vg.village_guard,predicate=vg:dark_area,predicate=!vg:angry,predicate=vg:chance_10] at @s run execute if entity @e[type=skeleton,tag=vg.village_guard,predicate=!vg:dark_area,distance=..64] run function vg:teleport/outside_cave

#VILLAGE GUARD PANIC SPEED
execute as @e[type=minecraft:skeleton,tag=vg.village_guard,predicate=vg:angry] at @s run execute if entity @e[nbt=!{Invulnerable:1b},tag=vg.enemy_mob,distance=..7,limit=1] run effect give @s speed 1 0 true
execute as @e[type=minecraft:skeleton,tag=vg.village_guard,predicate=vg:angry] at @s run execute if entity @e[nbt=!{Invulnerable:1b},tag=vg.enemy_mob,distance=..4,limit=1] run effect give @s speed 1 1 true

#MEET VG
execute as @a[gamemode=!spectator,advancements={vg:meet=false}] at @s run execute if entity @e[type=skeleton,tag=vg.village_guard,distance=..6] run function vg:meet